/*  aux_prot.h */
/* 	Copyright 2004-2005 Oswaldo Morizaki */

/* 	This file is part of ga-nn-ag.

    ga-nn-ag is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    ga-nn-ag is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ga-nn-ag; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* Random number functions */


extern int dice_toss(int seed, int partition);
extern int coin_toss(int seed);
extern int clean_char_buffer(char * char_buffer);
extern int is_connected(struct neuron * neuron1, struct neuron * neuron2, int * con_match);
extern int is_above(struct neuron * neuron1, struct neuron * neuron2, int *not_equal);
extern int copy_neuron(struct neuron * origin, struct neuron * destiny);
extern int sort_neuron_connections(struct neuron * neuron1);
extern int sort_neuron_array(struct neural_net * net);
extern int fwrite_neural_net(struct neural_net * net,	const char *filename);
extern int dwrite_neural_net(struct neural_net * net, int descriptor);
extern int load_vector(int size, float * vector, char * char_buffer);
extern int load_connection(int dimension, struct connection * con, char * char_buffer);
extern int load_nn_config(struct nn_config *conf, const char * filename);
extern int load_input(float *input_buffer, int num_elem_input, const char * filename);
extern int load_output(float *output_buffer, int num_elem_output, const char * filename);
extern int forward_propagation(struct neural_net * net, int num_elem_input);
extern int back_propagation(struct neural_net * net, int num_elem_input);
extern int weight_update(struct neural_net * net, int num_elem_input, struct nn_config * conf);

extern float rand_gen(int seed);
extern float derive(int delta_type, float net);
extern float output_layer_error(struct neural_net * net,	int num_elem_output, float *output_buffer);

extern double threshold(int threshold_type, float net);

extern void * free_neural_net(struct neural_net * target);
extern void * free_neuron(struct neuron * neuron1);
extern void * calloc_connection(int dimension, int momentum);
extern void * calloc_neuron(int dimension, int momentum, int num_con);
extern void * copy_neural_net(struct neural_net * origin, struct neural_net * destiny);
extern void * append_neuron(struct neural_net * parent1, struct neural_net * parent2);
extern void * fread_neural_net(struct neural_net * net,	const char * filename);

extern ssize_t writen(int fd, const void *vptr, size_t n);
extern ssize_t readn(int fd, void *vptr, size_t n);
